function ZombieDefense:StartActivity()
	print("Zombie Defense Activity Start");
	self.FightStage = { NOFIGHT = 0, DEFENDING = 1, ATTACK = 2, FIGHTSTAGECOUNT = 3 };
	self.zspawn1 = Timer();
	self.zspawn2 = Timer();
	self.zspawn3 = Timer();
	self.gametime = Timer();
	self.gametime:SetRealTimeLimitS(30);
	self.gameover = 0;
	self.ztime = 5000;
	self.InterruptTimer = Timer();
	self.Interrupt = 0;
	ActivityMan:GetActivity():SetTeamFunds(0,0);
	playerActor = CreateAHuman("Soldier Heavy");
	playerActor.Pos = Vector(2508,876);
	playerActor.Team = 0;
	self:SetPlayerBrain(playerActor, 0);
	self:SetLandingZone(playerActor.Pos, 0);
	playerActor:AddInventoryItem(CreateHDFirearm("Lady Pistol"));
	MovableMan:AddActor(playerActor);
	self:SwitchToActor(playerActor, 0, self:GetTeamOfPlayer(0));
	zlist = {"Spewer Thin","Spewer Medium","Spewer Fat"};
	wlist = {"Vomit Gun"};
	blist = {"Blue Bomb"};
	zombiecount = 0;
	zombiecap = 10;
	killcount = 0;
	pickup1 = 0;
	pickup2 = 0;
	pickup3 = 0;
	pickup4 = 0;
	pickup5 = 0;
	pickup6 = 0;
	pickup7 = 0;
end
	
function ZombieDefense:PauseActivity()
	print("Zombie Defense Activity Paused");
end

function ZombieDefense:EndActivity()
	print("Zombie Defense GAME OVER");
	self.gameover = 1;
	if self.WinnerTeam == Activity.TEAM_2 then
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("You're dead.  You were the last guy, too. So much for the human race.", Activity.PLAYER_1, 0, 5000, false);
	else
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("My god, you withstood the onslaught of ONE THOUSAND zombies. You is a champeen.", Activity.PLAYER_1, 0, 5000, false);
	end
end

function ZombieDefense:UpdateActivity()
	if MovableMan:IsActor(playerActor) then
		self:SetObservationTarget(playerActor.Pos, Activity.PLAYER_1);
	end
	
	if playerActor.Health == 0 then
		self.WinnerTeam = Activity.TEAM_2;
		ActivityMan:EndActivity();
	end

	if zombiecount < zombiecap then
		if -self.zspawn1:LeftTillSimMS(0) > self.ztime then
			local zombie1 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie1:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie1.Pos = Vector(400,850);
			zombie1.Team = 1;
			zombie1.AIMode = Actor.AIMODE_GOTO;
			zombie1:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			zombie1:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			MovableMan:AddActor(zombie1);
			self.zspawn1:Reset();
			zombiecount = zombiecount + 1;
		end
		if -self.zspawn2:LeftTillSimMS(0) > self.ztime then
			local zombie2 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie2:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie2.Pos = Vector(600,850);
			zombie2.Team = 1;
			zombie2.AIMode = Actor.AIMODE_GOTO;
			zombie2:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			zombie2:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			MovableMan:AddActor(zombie2);
			self.zspawn2:Reset();
			zombiecount = zombiecount + 1;
		end
		if -self.zspawn3:LeftTillSimMS(0) > self.ztime then
			local zombie3 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie3:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie3.Pos = Vector(800,850);
			zombie3.Team = 1;
			zombie3.AIMode = Actor.AIMODE_GOTO;
			zombie3:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			zombie3:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			MovableMan:AddActor(zombie3);
			self.zspawn3:Reset();
			zombiecount = zombiecount + 1;
		end
	end
	
	for actor in MovableMan.Actors do
        if SceneMan.Scene:WithinArea("Boundary", actor.Pos) then
			if actor.Team == 0 then
				actor.Vel = actor.Vel * -1;
			end
        end
    end
	
	for item in MovableMan.Items do
		if item.PresetName == "Vomit Gun" then
			item.ToSettle = true;
		end
		if item.PresetName == "Blue Bomb" then
			item.ToSettle = true;
		end
	end
	
	if killcount >= 25 and pickup1 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Auto Pistol"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Twenty five zombies killed! Auto Pistol unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup1 = 1;
		zombiecap = 20;
	end

	if killcount >= 50 and pickup2 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Rifle Long"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Fifty zombies killed! Rifle Long unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup2 = 1;
		self.ztime = 4500;
	end
	
	if killcount >= 75 and pickup3 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Sniper Rifle"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Seventy five zombies killed! Sniper Rifle unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup3 = 1;
		self.ztime = 4000;
	end
	
	if killcount >= 100 and pickup4 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("TommyGun"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("One hundred zombies killed! Tommy Gun unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup4 = 1;
		zombiecap = 30;
		self.ztime = 3000;
		if playerActor.Health < 85 then
			self.Interrupt = 5000;
			self.InterruptTimer:Reset();
			self:ResetMessageTimer(Activity.PLAYER_1);
			FrameMan:ClearScreenText(Activity.PLAYER_1);
			FrameMan:SetScreenText("HEALTH BONUS", Activity.PLAYER_1, 0, 5000, false);
			playerActor.Health = playerActor.Health + 15;
		end
	end
	
	if killcount >= 200 and pickup5 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("M1600"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Two hundred zombies killed! M1600 unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup5 = 1;
	end
	
	if killcount >= 400 and pickup6 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Revolver Cannon"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Four hundred zombies killed! Revolver Cannon unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup6 = 1;
		zombiecap = 40;
	end
	
	if killcount >= 750 and pickup7 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Rocket Launcher"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Seven hundred fifty zombies killed! Rocket launcher unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup7 = 1;
		self.ztime = 2500;
	end
	
	if killcount >= 1000 then
		self.WinnerTeam = Activity.TEAM_1;
		ActivityMan:EndActivity();
	end
end
	